#include <sstream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <string>
#include <cassert>
#include <ctime>
#include <map>
#include <math.h>
#include <cstdio>
#include <set>
#include <deque>
#include <memory.h>
#include <queue>

#pragma comment(linker, "/STACK:64000000")
typedef long long ll;

using namespace std;

const int MAXN = 1 << 20;
const int MOD = 1; // 1000 * 1000 * 1000 + 7;

int main() {
	freopen("fence.in", "r", stdin);
	freopen("fence.out", "w", stdout);

	int n;
	string s;
	while (cin >> n >> s) {
		vector<int> a;
		for (int i = 0; i < n; i++) {
			if (s[i] == '.') continue;
			int len = 0;
			while (i < n && s[i] == '#') {
				len++;
				i++;
			}
			a.push_back(len);
		}
		sort(a.begin(), a.end());
		
		vector<int> ans(n + 1, -1);
		set<int> st;
		for (int i = 0; i <= n; i++) st.insert(i);

		for (int i = 0; i < (a.empty() ? -1 : a[0]); i++) {
			int mn = 0, mx = 0;
			for (int j = 0; j < (int)a.size(); j++) {
				mn += (a[j] + i) / (i + 1);
				mx += a[j] - i;
			}
			while (1) {
				set<int> ::iterator it = st.lower_bound(mn);
				if (it == st.end() || *it > mx) {
					break;
				}
				ans[*it] = i;
				st.erase(it);
			}
		}
		for (int i = 1; i <= n; i++) printf("%d%c", ans[i], " \n"[i == n]);
	}

	return 0;
}
